LeetCode 239. Sliding Window Maximum

Given an array nums, there is a sliding window of size k which is moving from the very left of the array to the very right. You can only see the k numbers in the window. Each time the sliding window moves right by one position. Return the max sliding window.

Example:

Input: nums = [1,3,-1,-3,5,3,6,7], and k = 3
Output: [3,3,5,5,6,7] 

Explanation: 

Window position                Max
---------------               -----
[1  3  -1] -3  5  3  6  7       3
 1 [3  -1  -3] 5  3  6  7       3
 1  3 [-1  -3  5] 3  6  7       5
 1  3  -1 [-3  5  3] 6  7       5
 1  3  -1  -3 [5  3  6] 7       6
 1  3  -1  -3  5 [3  6  7]      7

Note:
You may assume k is always valid, 1 ≤ k ≤ input array’s size for non-empty array.

Follow up:
Could you solve it in linear time?

由于只求最大值,那么在k个内,只需要记录一个递减数组,因为如果递增了,那么递增点的前一个数字永远是用不到的,因为要求的是一个范围内的最大值。由于需要两头操作,左边头返回答案,右边头判断需不需要remove来保证递减性质,并且BST的所有操作都是O(logn)的,因此可以用treeset来写这道题。

    public int[] maxSlidingWindow(int[] nums, int k) {
        int n = nums.length;
        if (n == 0) return new int[]{};
        TreeSet<Integer> set = new TreeSet<>((o1, o2) -> (nums[o2] == nums[o1] ? o1 - o2 : nums[o2] - nums[o1]));
        int[] res = new int[n - k + 1];
        for (int i = 0; i < n; i++) {
            if (i >= k) set.remove(i - k);
            set.add(i);
            while (nums[set.last()] < nums[i]) set.remove(set.last());
            if (i >= k - 1) {
                res[i - k + 1] = nums[set.first()];
            }
        }
        return res;
    }
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值